diff -uwrN sourceold/scripts/tcw_building.cpp source/scripts/tcw_building.cpp
--- sourceold/scripts/tcw_building.cpp	2012-06-09 08:11:12.324218700 +0800
+++ source/scripts/tcw_building.cpp	2012-07-31 21:54:12.201171800 +0800
@@ -42,6 +42,12 @@
 		Create_2D_WAV_Sound_Team("gdi_airfield_destroyed_nod.wav",0);
 		Send_Message(255,255,255,"GDI Airfield destroyed.");
 	}
+	else if (strcmp(Commands->Get_Preset_Name(obj),"TCW_GDI_Watchtower") == 0)
+	{
+		Create_2D_WAV_Sound_Team("gdi_watchtower_destroyed_gdi.wav",1);
+		Create_2D_WAV_Sound_Team("gdi_watchtower_destroyed_nod.wav",0);
+		Send_Message(255,255,255,"GDI Watch Tower destroyed.");
+	}
 	else if (strcmp(Commands->Get_Preset_Name(obj),"TCW_GDI_War_Factory") == 0)
 	{
 		Create_2D_WAV_Sound_Team("gdi_warfactory_destroyed_gdi.wav",1);
@@ -171,6 +177,13 @@
 					Send_Message_Team(0,255,255,255,"GDI Tiberium Refinery under attack.");
 					Send_Message_Team(1,255,255,255,"Warning GDI Tiberium Refinery under attack.");
 				}
+				else if (strcmp(Commands->Get_Preset_Name(obj),"TCW_GDI_Watchtower") == 0)
+				{
+					Create_2D_WAV_Sound_Team("gdi_watchtower_under_attack_gdi.wav",1);
+					Create_2D_WAV_Sound_Team("gdi_watchtower_under_attack_nod.wav",0);
+					Send_Message_Team(1,255,255,255,"Warning: GDI Watch Tower under attack.");
+					Send_Message_Team(0,255,255,255,"GDI Watch Tower under attack.");
+				}
 				else if (strcmp(Commands->Get_Preset_Name(obj),"TCW_GDI_Airfield") == 0)
 				{
 					Create_2D_WAV_Sound_Team("gdi_airfield_under_attack_gdi.wav",1);
@@ -363,7 +376,7 @@
 {
 	if (play)
 	{
-		if (damage > 0.5f)
+		if (damage > 0.1f)
 		{
 			play = false;
 			Commands->Start_Timer(obj,this,25.0f,100100);
diff -uwrN sourceold/scripts/tcw_center_point.cpp source/scripts/tcw_center_point.cpp
--- sourceold/scripts/tcw_center_point.cpp	2012-06-09 08:11:12.362304600 +0800
+++ source/scripts/tcw_center_point.cpp	2012-08-04 10:17:08.602539000 +0800
@@ -16,355 +16,191 @@
 #include "engine.h"
 #include "BuildingGameObj.h"
 #include "tcw_center_point.h"
-#include "GameObjManager.h"
-#include "SoldierGameObj.h"
-#include "VehicleGameObj.h"
 
-//0=nod 1=gdi 2=neu current animations for spawnpads
+#define ISREPAIR(Damage) (Damage < 0.0f)
+#define ISVALIDPLAYER(Team) (Team == 0 || Team == 1)
+#define CUSTOM_EVENT_INITIALIZE_TURRET 873423
+#define CUSTOM_EVENT_START_TURRET 978356
+#define CUSTOM_EVENT_STOP_TURRET 957832
 
-void tcw_cp_cruiser_countdown_point::Created(GameObject *obj)
+void TCW_CP_Cruiser_Countdown_Point::Created(GameObject *obj)
 {
 	Commands->Set_Animation(obj,"DOM_NODE.DOM_NODE",false,0,2,2,false);
-	spawnpad1 = Get_Int_Parameter("SpawnPad1ID");
-	if (Commands->Find_Object(spawnpad1))
-	{
-		Commands->Set_Animation(Commands->Find_Object(spawnpad1),"NEU_PLATFRM_2.NEU_PLATFRM_2",false,0,2,2,false);
-	}
-	spawnpad2 = Get_Int_Parameter("SpawnPad2ID");
-	if (Commands->Find_Object(spawnpad2))
-	{
-		Commands->Set_Animation(Commands->Find_Object(spawnpad2),"NEU_PLATFRM_2.NEU_PLATFRM_2",false,0,2,2,false);
-	}
-	spawnpad3 = Get_Int_Parameter("SpawnPad3ID");
-	if (Commands->Find_Object(spawnpad3))
-	{
-		Commands->Set_Animation(Commands->Find_Object(spawnpad3),"NEU_PLATFRM_2.NEU_PLATFRM_2",false,0,2,2,false);
-	}
-	spawnpad4 = Get_Int_Parameter("SpawnPad4ID");
-	if (Commands->Find_Object(spawnpad4))
-	{
-		Commands->Set_Animation(Commands->Find_Object(spawnpad4),"NEU_PLATFRM_2.NEU_PLATFRM_2",false,0,2,2,false);
-	}
-	nod_bar_turret_id = 100065; nod_ref_turret_id = 100067; gdi_hand_turret_id = 100068; gdi_ref_turret_id = 100070;	
-	nodveh1id = 0; nodveh2id = 0; gdiveh1id = 0; gdiveh2id = 0;
+	SpawnPadIDs[0] = Get_Int_Parameter("VehSpawnPadID1");
+	SpawnPadIDs[1] = Get_Int_Parameter("VehSpawnPadID2");
+	SpawnPadIDs[2] = Get_Int_Parameter("VehSpawnPadID3");
+	SpawnPadIDs[3] = Get_Int_Parameter("VehSpawnPadID4");
+	for(int Index = 0; Index < 4; Index++)
+		Commands->Set_Animation(Commands->Find_Object(SpawnPadIDs[Index]),"NEU_PLATFRM_2.NEU_PLATFRM_2",false,0,2,2,false);
+	NodTurretIDs[0] = Get_Int_Parameter("NodTurretID1");
+	NodTurretIDs[1] = Get_Int_Parameter("NodTurretID2");
+	GDITurretIDs[0] = Get_Int_Parameter("GDITurretID1");
+	GDITurretIDs[1] = Get_Int_Parameter("GDITurretID2");
+	Commands->Send_Custom_Event(obj, Commands->Find_Object(NodTurretIDs[0]), CUSTOM_EVENT_INITIALIZE_TURRET, 1, 0);
+	Commands->Send_Custom_Event(obj, Commands->Find_Object(NodTurretIDs[1]), CUSTOM_EVENT_INITIALIZE_TURRET, 1, 0);
+	Commands->Send_Custom_Event(obj, Commands->Find_Object(GDITurretIDs[0]), CUSTOM_EVENT_INITIALIZE_TURRET, 0, 0);
+	Commands->Send_Custom_Event(obj, Commands->Find_Object(GDITurretIDs[1]), CUSTOM_EVENT_INITIALIZE_TURRET, 0, 0);
+	Vehs[0] = new VehicleReinforcements(Get_Parameter("GDIVehicle1"), Get_Vector3_Parameter("GDIVehicle1Pos"), Get_Float_Parameter("GDIVehicle1Facing"), 1);
+	Vehs[1] = new VehicleReinforcements(Get_Parameter("GDIVehicle2"), Get_Vector3_Parameter("GDIVehicle2Pos"), Get_Float_Parameter("GDIVehicle2Facing"), 1);
+	Vehs[2] = new VehicleReinforcements(Get_Parameter("NodVehicle1"), Get_Vector3_Parameter("NodVehicle1Pos"), Get_Float_Parameter("NodVehicle1Facing"), 0);
+	Vehs[3] = new VehicleReinforcements(Get_Parameter("NodVehicle2"), Get_Vector3_Parameter("NodVehicle2Pos"), Get_Float_Parameter("NodVehicle2Facing"), 0);
 	Commands->Set_Player_Type(obj,-2);
-	Commands->Set_Health(obj,2.0f);
-	create_cruiser_countdown_object = true;
-	trigger_neutral_damage = true;
+	Commands->Set_Health(obj, 2);
+	Captured = false;
+	CaptureType = -2;
+	Health = 2;
 }
-void tcw_cp_cruiser_countdown_point::Damaged(GameObject *obj, GameObject *damager, float damage)
-{
-	if (Commands->Is_A_Star(damager))//is it a player?
-	{
-		if ((damage < 0.0f) && (Commands->Get_Player_Type(obj) == -2))
-		{
-			if (Commands->Get_Health(obj) == Commands->Get_Max_Health(obj))//if fully repaired
-			{
-				if (Commands->Get_Player_Type(damager) == 0)
+
+void TCW_CP_Cruiser_Countdown_Point::Damaged(GameObject *obj, GameObject *damager, float damage)
 				{
-					trigger_neutral_damage = true;
-					Commands->Set_Player_Type(obj,0);
-					Commands->Set_Animation(obj,"DOM_NODE.DOM_NODE",false,0,0,0,false);
-					if (Commands->Find_Object(spawnpad1))
+	if(Commands->Is_A_Star(damager)) // Only Stars may do something with me.
 					{
-						Commands->Set_Animation(Commands->Find_Object(spawnpad1),"NEU_PLATFRM_2.NEU_PLATFRM_2",false,0,0,0,false);
-					}
-					if (Commands->Find_Object(spawnpad2))
+		if(ISREPAIR(damage)) // Check if it's repair damage (damage < 0.0).
 					{
-						Commands->Set_Animation(Commands->Find_Object(spawnpad2),"NEU_PLATFRM_2.NEU_PLATFRM_2",false,0,0,0,false);
-					}
-					if (Commands->Find_Object(spawnpad3))
+			if(!ISVALIDPLAYER(Commands->Get_Player_Type(damager))) // When not a valid player ignore the repairing.
 					{
-						Commands->Set_Animation(Commands->Find_Object(spawnpad3),"NEU_PLATFRM_2.NEU_PLATFRM_2",false,0,0,0,false);
+				Commands->Set_Health(obj, Health);
+				return;
 					}
-					if (Commands->Find_Object(spawnpad4))
+			Health = Commands->Get_Health(obj);
+			if(!Captured && Commands->Get_Health(obj) == Commands->Get_Max_Health(obj)) // When I'm not captured and I've reached maximum health.
 					{
-						Commands->Set_Animation(Commands->Find_Object(spawnpad4),"NEU_PLATFRM_2.NEU_PLATFRM_2",false,0,0,0,false);
-					}
-
-					if (create_cruiser_countdown_object)//if the cruisercountdown object may be created
+				Health = Commands->Get_Max_Health(obj);
+				Captured = true;
+				CaptureType = Commands->Get_Player_Type(damager);
+				Commands->Set_Player_Type(obj, CaptureType);
+				Commands->Set_Animation(obj,"DOM_NODE.DOM_NODE",false,0,0,0,false);
+				for(int Index = 0; Index < 4; Index++)
+					Commands->Set_Animation(Commands->Find_Object(Index),"NEU_PLATFRM_2.NEU_PLATFRM_2",false,0,0,0,false);
+				Commands->Start_Timer(obj, this, 60, 1);
+				Commands->Give_Money(damager, 500, true);
+				if(CaptureType == 0)
 					{
 						Send_Message(255,255,255,"Nod has captured the Countdown Control Point. One Minute for Cruiser Attacks.");
-						create_cruiser_countdown_object = false;//its being created here so we set it to false so it doesnt get made a 2nd time
-						Vector3 countdown_object_pos;
-						countdown_object_pos.X = 0.0f; countdown_object_pos.Y = 0.0f; countdown_object_pos.Z = 0.0f;
-						GameObject *countdown_object = Commands->Create_Object("Invisible_Object",countdown_object_pos);
-
-						char prms[250];
-						sprintf(prms,"%d,%d,%d,%d,%d",0,nod_bar_turret_id,nod_ref_turret_id,gdi_hand_turret_id,gdi_ref_turret_id);
-						Attach_Script_Once(countdown_object,"tcw_cp_cruiser_countdown",prms);
-
 						Create_2D_WAV_Sound_Team("ControlPointCaptured_Nod.wav",0);
-						Create_2D_WAV_Sound_Team("ControlPointLost_GDI.wav",1);
-
-						if (Commands->Get_Player_Type(damager) == Commands->Get_Player_Type(obj))
-						{
-							Commands->Give_Money(damager,500.0f,true);
-						}
-
-						if (!Commands->Find_Object(nodveh1id))
-						{
-							if (strcmp(Get_Parameter("NodVeh1"), "0") != 0)
-							{
-								Vector3 nodveh1pos = Get_Vector3_Parameter("NodVeh1Pos");
-								float nodveh1fac = Get_Float_Parameter("NodVeh1Facing");
-								GameObject *nodveh1 = Commands->Create_Object(Get_Parameter("NodVeh1"),nodveh1pos);
-								Commands->Set_Facing(nodveh1,nodveh1fac);
-								nodveh1id = Commands->Get_ID(nodveh1);
-								Attach_Script_Once(nodveh1,"tcw_domination_vehicle","0");
-							}
-						}
-						if (!Commands->Find_Object(nodveh2id))
-						{
-							if (strcmp(Get_Parameter("NodVeh2"), "0") != 0)
-							{
-								Vector3 nodveh2pos = Get_Vector3_Parameter("NodVeh2Pos");
-								float nodveh2fac = Get_Float_Parameter("NodVeh2Facing");
-								GameObject *nodveh2 = Commands->Create_Object(Get_Parameter("NodVeh2"),nodveh2pos);
-								Commands->Set_Facing(nodveh2,nodveh2fac);
-								nodveh2id = Commands->Get_ID(nodveh2);
-								Attach_Script_Once(nodveh2,"tcw_domination_vehicle","0");
-							}
-						}
-					}
+					Vehs[2] ? Vehs[2]->Create() : 0;
+					Vehs[3] ? Vehs[3]->Create() : 0;
 				}
-				else if (Commands->Get_Player_Type(damager) == 1)
-				{
-					trigger_neutral_damage = true;
-					Commands->Set_Player_Type(obj,1);
-					Commands->Set_Animation(obj,"DOM_NODE.DOM_NODE",false,0,1,1,false);
-					if (Commands->Find_Object(spawnpad1))
-					{
-						Commands->Set_Animation(Commands->Find_Object(spawnpad1),"NEU_PLATFRM_2.NEU_PLATFRM_2",false,0,1,1,false);
-					}
-					if (Commands->Find_Object(spawnpad2))
-					{
-						Commands->Set_Animation(Commands->Find_Object(spawnpad2),"NEU_PLATFRM_2.NEU_PLATFRM_2",false,0,1,1,false);
-					}
-					if (Commands->Find_Object(spawnpad3))
-					{
-						Commands->Set_Animation(Commands->Find_Object(spawnpad3),"NEU_PLATFRM_2.NEU_PLATFRM_2",false,0,1,1,false);
-					}
-					if (Commands->Find_Object(spawnpad4))
-					{
-						Commands->Set_Animation(Commands->Find_Object(spawnpad4),"NEU_PLATFRM_2.NEU_PLATFRM_2",false,0,1,1,false);
-					}
-
-					if (create_cruiser_countdown_object)
+				else if(CaptureType == 1)
 					{
 						Send_Message(255,255,255,"GDI has captured the Countdown Control Point. One Minute for Cruiser Attacks.");
-						create_cruiser_countdown_object = false;
-						Vector3 countdown_object_pos;
-						countdown_object_pos.X = 0.0f; countdown_object_pos.Y = 0.0f; countdown_object_pos.Z = 0.0f;
-						GameObject *countdown_object = Commands->Create_Object("Invisible_Object",countdown_object_pos);
-						
-						char prms[250];
-						sprintf(prms,"%d,%d,%d,%d,%d",1,nod_bar_turret_id,nod_ref_turret_id,gdi_hand_turret_id,gdi_ref_turret_id);
-						Attach_Script_Once(countdown_object,"tcw_cp_cruiser_countdown",prms);
-
-						Create_2D_WAV_Sound_Team("ControlPointLost_Nod.wav",0);
 						Create_2D_WAV_Sound_Team("ControlPointCaptured_GDI.wav",1);
-
-						if (Commands->Get_Player_Type(damager) == Commands->Get_Player_Type(obj))
-						{
-							Commands->Give_Money(damager,500.0f,true);
-						}
-
-						if (!Commands->Find_Object(nodveh1id))
-						{
-							if (strcmp(Get_Parameter("GDIVeh1"), "0") != 0)
-							{
-								Vector3 gdiveh1pos = Get_Vector3_Parameter("GDIVeh1Pos");
-								float gdiveh1fac = Get_Float_Parameter("GDIVeh1Facing");
-								GameObject *gdiveh1 = Commands->Create_Object(Get_Parameter("GDIVeh1"),gdiveh1pos);
-								Commands->Set_Facing(gdiveh1,gdiveh1fac);
-								gdiveh1id = Commands->Get_ID(gdiveh1);
-								Attach_Script_Once(gdiveh1,"tcw_domination_vehicle","1");
-							}
-						}
-						if (!Commands->Find_Object(nodveh2id))
-						{
-							if (strcmp(Get_Parameter("GDIVeh2"), "0") != 0)
-							{
-								Vector3 gdiveh2pos = Get_Vector3_Parameter("GDIVeh2Pos");
-								float gdiveh2fac = Get_Float_Parameter("GDIVeh2Facing");
-								GameObject *gdiveh2 = Commands->Create_Object(Get_Parameter("GDIVeh2"),gdiveh2pos);
-								Commands->Set_Facing(gdiveh2,gdiveh2fac);
-								gdiveh2id = Commands->Get_ID(gdiveh2);
-								Attach_Script_Once(gdiveh2,"tcw_domination_vehicle","1");
+					Vehs[0] ? Vehs[0]->Create() : 0;
+					Vehs[1] ? Vehs[1]->Create() : 0;
 							}
 						}
 					}
-				}
-			}
-		}
-		else if (damage > 0.0f)
+		else
 		{
-			if (Commands->Get_Player_Type(damager) == 1)//if its gdi attacking it
+			if(Captured)
 			{
-				if (damage >= Commands->Get_Health(obj))//point is destroyed
+				if(!ISVALIDPLAYER(Commands->Get_Player_Type(damager))) // When not a valid player ignore the damage being done.
 				{
-					Commands->Set_Player_Type(obj,-2);//it now belongs to gdi because they fully destroyed it
-					Commands->Set_Health(obj,2.0f);//we cant allow them to REALLY destroy it, otherwise the script halts and stuff....
-					if (trigger_neutral_damage)
+					Commands->Set_Health(obj, Health);
+					return;
+				}
+				Health = Commands->Get_Health(obj);
+				if(damage >= Commands->Get_Health(obj)) // We are destroyed, point lost.
 					{
+					Health = 2;
+					Captured = false;
+					Commands->Set_Health(obj, 2);
+					Commands->Set_Player_Type(obj, -2);
 						Commands->Set_Animation(obj,"DOM_NODE.DOM_NODE",false,0,2,2,false);
-						Commands->Set_Animation(Commands->Find_Object(spawnpad1),"NEU_PLATFRM_2.NEU_PLATFRM_2",false,0,2,2,false);
-						Commands->Set_Animation(Commands->Find_Object(spawnpad2),"NEU_PLATFRM_2.NEU_PLATFRM_2",false,0,2,2,false);
-						Commands->Set_Animation(Commands->Find_Object(spawnpad3),"NEU_PLATFRM_2.NEU_PLATFRM_2",false,0,2,2,false);
-						Commands->Set_Animation(Commands->Find_Object(spawnpad4),"NEU_PLATFRM_2.NEU_PLATFRM_2",false,0,2,2,false);
+					for(int Index = 0; Index < 4; Index++)
+						Commands->Set_Animation(Commands->Find_Object(SpawnPadIDs[Index]),"NEU_PLATFRM_2.NEU_PLATFRM_2",false,0,2,2,false);
+					Commands->Send_Custom_Event(obj, Commands->Find_Object(NodTurretIDs[0]), CUSTOM_EVENT_STOP_TURRET, 0, 0);
+					Commands->Send_Custom_Event(obj, Commands->Find_Object(NodTurretIDs[1]), CUSTOM_EVENT_STOP_TURRET, 0, 0);
+					Commands->Send_Custom_Event(obj, Commands->Find_Object(GDITurretIDs[0]), CUSTOM_EVENT_STOP_TURRET, 0, 0);
+					Commands->Send_Custom_Event(obj, Commands->Find_Object(GDITurretIDs[1]), CUSTOM_EVENT_STOP_TURRET, 0, 0);
+					if(CaptureType == 0)
+					{
 						Send_Message(255,255,255,"Cruiser Attacks on GDI halted. Countdown Point destroyed.");
-						Vector3 tur1pos = Commands->Get_Position(Commands->Find_Object(nod_bar_turret_id));//bar attacking turret for nod
-						Vector3 tur2pos = Commands->Get_Position(Commands->Find_Object(nod_ref_turret_id));//ref attacking turret for nod
-						float facingtur1 = Commands->Get_Facing(Commands->Find_Object(nod_bar_turret_id));
-						float facingtur2 = Commands->Get_Facing(Commands->Find_Object(nod_ref_turret_id));
-						Commands->Destroy_Object(Commands->Find_Object(nod_bar_turret_id));
-						Commands->Destroy_Object(Commands->Find_Object(nod_ref_turret_id));
-						GameObject *tur1 = Commands->Create_Object("TCW_Cruiser_Cannon_CDP",tur1pos);
-						GameObject *tur2 = Commands->Create_Object("TCW_Cruiser_Cannon_CDP",tur2pos);
-						Commands->Set_Facing(tur1,facingtur1); 
-						Commands->Set_Player_Type(tur1,0);
-						Commands->Set_Facing(tur2,facingtur2); 
-						Commands->Set_Player_Type(tur2,0);
-						nod_bar_turret_id = Commands->Get_ID(tur1);//this is the new bar attacking turret for nod
-						nod_ref_turret_id = Commands->Get_ID(tur2);//this is the new ref attacking turret for nod
-						create_cruiser_countdown_object = true;
 						Create_2D_WAV_Sound_Team("ControlPointLost_Nod.wav",0);
-						//destroy the spawned vehicles
-						if ( (Commands->Find_Object(nodveh1id)) && (!Get_Vehicle_Driver(Commands->Find_Object(nodveh1id))) )
-						{
-							Commands->Apply_Damage(Commands->Find_Object(nodveh1id),999999.0f,"Steel",obj);		nodveh1id = 0;
-						}
-						if ( (Commands->Find_Object(nodveh2id)) && (!Get_Vehicle_Driver(Commands->Find_Object(nodveh2id))) )
-						{
-							Commands->Apply_Damage(Commands->Find_Object(nodveh2id),999999.0f,"Steel",obj);		nodveh2id = 0;
-						}
-						trigger_neutral_damage = false;
-					}
-				}
+						Vehs[2] ? Commands->Apply_Damage(Vehs[2]->Is_Alive_And_Kicking(), 9999, "BlamoKiller", 0) : 0;
+						Vehs[3] ? Commands->Apply_Damage(Vehs[3]->Is_Alive_And_Kicking(), 9999, "BlamoKiller", 0) : 0;
 			}
-			else if (Commands->Get_Player_Type(damager) == 0)//if its nod attacking it
+					else if(CaptureType == 1)
 			{
-				if (damage >= Commands->Get_Health(obj))//point is destroyed
-				{
-					Commands->Set_Player_Type(obj,-2);//it now belongs to nod because they fully destroyed it
-					Commands->Set_Health(obj,2.0f);//we cant allow them to REALLY destroy it, otherwise the script halts and stuff....
-					if (trigger_neutral_damage)
-					{
-						Commands->Set_Animation(obj,"DOM_NODE.DOM_NODE",false,0,2,2,false);
-						Commands->Set_Animation(Commands->Find_Object(spawnpad1),"NEU_PLATFRM_2.NEU_PLATFRM_2",false,0,2,2,false);
-						Commands->Set_Animation(Commands->Find_Object(spawnpad2),"NEU_PLATFRM_2.NEU_PLATFRM_2",false,0,2,2,false);
-						Commands->Set_Animation(Commands->Find_Object(spawnpad3),"NEU_PLATFRM_2.NEU_PLATFRM_2",false,0,2,2,false);
-						Commands->Set_Animation(Commands->Find_Object(spawnpad4),"NEU_PLATFRM_2.NEU_PLATFRM_2",false,0,2,2,false);
 						Send_Message(255,255,255,"Cruiser Attacks on Nod halted. Countdown Point destroyed.");
-						Vector3 tur1pos = Commands->Get_Position(Commands->Find_Object(gdi_hand_turret_id));//hon attacking turret for gdi
-						Vector3 tur2pos = Commands->Get_Position(Commands->Find_Object(gdi_ref_turret_id));//ref attacking turret for gdi
-						float facingtur1 = Commands->Get_Facing(Commands->Find_Object(gdi_hand_turret_id));
-						float facingtur2 = Commands->Get_Facing(Commands->Find_Object(gdi_ref_turret_id));	
-						Commands->Destroy_Object(Commands->Find_Object(gdi_hand_turret_id));
-						Commands->Destroy_Object(Commands->Find_Object(gdi_ref_turret_id));
-						GameObject *tur1 = Commands->Create_Object("TCW_Cruiser_Cannon_CDP",tur1pos);
-						GameObject *tur2 = Commands->Create_Object("TCW_Cruiser_Cannon_CDP",tur2pos);
-						Commands->Set_Facing(tur1,facingtur1); 
-						Commands->Set_Player_Type(tur1,1);
-						Commands->Set_Facing(tur2,facingtur2); 
-						Commands->Set_Player_Type(tur2,1);
-						gdi_hand_turret_id = Commands->Get_ID(tur1);//this is the new hand attacking turret for gdi
-						gdi_ref_turret_id = Commands->Get_ID(tur2);//this is the new ref attacking turret for gdi
-						create_cruiser_countdown_object = true;
 						Create_2D_WAV_Sound_Team("ControlPointLost_GDI.wav",1);
-
-						//destroy the spawned vehicles
-						if ( (Commands->Find_Object(gdiveh1id)) && (!Get_Vehicle_Driver(Commands->Find_Object(gdiveh1id))) )
-						{
-							Commands->Apply_Damage(Commands->Find_Object(gdiveh1id),999999.0f,"Death",obj);		gdiveh1id = 0;
-						}
-						if ( (Commands->Find_Object(gdiveh2id)) && (!Get_Vehicle_Driver(Commands->Find_Object(gdiveh2id))) )
-						{
-							Commands->Apply_Damage(Commands->Find_Object(gdiveh2id),999999.0f,"Death",obj);		gdiveh2id = 0;
-						}
-						trigger_neutral_damage = false;
-					}
+						Vehs[0] ? Commands->Apply_Damage(Vehs[0]->Is_Alive_And_Kicking(), 9999, "BlamoKiller", 0) : 0;
+						Vehs[1] ? Commands->Apply_Damage(Vehs[1]->Is_Alive_And_Kicking(), 9999, "BlamoKiller", 0) : 0;
 				}
+					CaptureType = -2;
 			}
 		}
+			else
+				Commands->Set_Health(obj, 2);
 	}
 }
-void tcw_cp_cruiser_countdown_point::Register_Auto_Save_Variables()
-{
-	Auto_Save_Variable(&create_cruiser_countdown_object,sizeof(create_cruiser_countdown_object),1);
-	Auto_Save_Variable(&nodveh1id,sizeof(nodveh1id),2);
-	Auto_Save_Variable(&nodveh2id,sizeof(nodveh2id),3);
-	Auto_Save_Variable(&gdiveh1id,sizeof(gdiveh1id),4);
-	Auto_Save_Variable(&gdiveh2id,sizeof(gdiveh2id),5);
-	Auto_Save_Variable(&trigger_neutral_damage,sizeof(trigger_neutral_damage),6);
 }
 
-void tcw_cp_cruiser_countdown::Created(GameObject *obj)
+void TCW_CP_Cruiser_Countdown_Point::Timer_Expired(GameObject *obj, int number)
+{
+	if(number == 1 && Captured)
 {
-	team = Get_Int_Parameter("Team");
-	turretbarnod = Get_Int_Parameter("NodTurretBar_ID");
-	turretrefnod = Get_Int_Parameter("NodTurretRef_ID");
-	turrethongdi = Get_Int_Parameter("GDITurretHon_ID");
-	turretrefgdi = Get_Int_Parameter("GDITurretRef_ID");
-	if (team == 0)
+		Commands->Create_2D_WAV_Sound("attackalert.mp3");
+		if(CaptureType == 0)
 	{
-		Commands->Start_Timer(obj,this,60.0f,100);
+			Commands->Send_Custom_Event(obj, Commands->Find_Object(NodTurretIDs[0]), CUSTOM_EVENT_START_TURRET, BuildingConstants::TYPE_REFINERY, 0);
+			Commands->Send_Custom_Event(obj, Commands->Find_Object(NodTurretIDs[1]), CUSTOM_EVENT_START_TURRET, BuildingConstants::TYPE_SOLDIER_FACTORY, 0);
 	}
-	else if (team == 1)
+		else if(CaptureType == 1)
 	{
-		Commands->Start_Timer(obj,this,60.0f,101);
+			Commands->Send_Custom_Event(obj, Commands->Find_Object(GDITurretIDs[0]), CUSTOM_EVENT_START_TURRET, BuildingConstants::TYPE_REFINERY, 0);
+			Commands->Send_Custom_Event(obj, Commands->Find_Object(GDITurretIDs[1]), CUSTOM_EVENT_START_TURRET, BuildingConstants::TYPE_SOLDIER_FACTORY, 0);
 	}
 }
-void tcw_cp_cruiser_countdown::Timer_Expired(GameObject *obj, int number)
-{
-	if (number == 100) // nod timer hits so we need the turrets from nod which attack gdi base:
-	{
-		//100065 -> bar			100067 -> ref (turrets)
-		//100062 -> barattack	100071 -> refattack (attackpoints)
-		Attach_Script_Once(Commands->Find_Object(turretbarnod),"tcw_cp_cruiser_attack","100062");//turret 1 that attacks the barracks
-		Attach_Script_Once(Commands->Find_Object(turretrefnod),"tcw_cp_cruiser_attack","100071");//turret 2 that attacks the refinery
 	}
-	else if (number == 101)
+
+void TCW_CP_Cruiser_Attack::Created(GameObject *obj)
 	{
-		//100068 -> hand			100070 -> ref (turrets)
-		//100073 -> handattack		100072 -> refattack (attackpoints)
-		Attach_Script_Once(Commands->Find_Object(turrethongdi),"tcw_cp_cruiser_attack","100073");//turret 1 that attacks the hand
-		Attach_Script_Once(Commands->Find_Object(turretrefgdi),"tcw_cp_cruiser_attack","100072");//turret 2 that attacks the refinery
-	}
+	Set_Skin(obj, "Blamo");
+	Commands->Set_Shield_Type(obj, "Blamo");
+	Commands->Set_Player_Type(obj, -2);
+	Commands->Innate_Disable(obj);
 }
-void tcw_cp_cruiser_countdown::Register_Auto_Save_Variables()
+
+void TCW_CP_Cruiser_Attack::Action_Complete(GameObject *obj, int action, ActionCompleteReason reason)
 {
-	Auto_Save_Variable(&team,sizeof(team),1);
-	Auto_Save_Variable(&turretbarnod,sizeof(turretbarnod),2);
-	Auto_Save_Variable(&turretrefnod,sizeof(turretrefnod),3);
-	Auto_Save_Variable(&turrethongdi,sizeof(turrethongdi),4);
-	Auto_Save_Variable(&turretrefgdi,sizeof(turretrefgdi),5);
+	if(reason == ACTION_COMPLETE_NORMAL)
+		Commands->Action_Reset(obj, 100);
 }
 
-void tcw_cp_cruiser_attack::Created(GameObject *obj)//this script will immideately attack whatever is passed as the attack id
+void TCW_CP_Cruiser_Attack::Custom(GameObject *obj,int type,int param,GameObject *sender)
 {
-	Commands->Start_Timer(obj,this,1.0f,250);
-	Commands->Create_2D_WAV_Sound("attackalert.wav");
+	if(type == CUSTOM_EVENT_INITIALIZE_TURRET)
+	{
+		AttackTeam = param;
+		if(AttackTeam == 0)
+			Commands->Set_Player_Type(obj, 1);
+		else if(AttackTeam == 1)
+			Commands->Set_Player_Type(obj, 0);
+		else
+			Commands->Set_Player_Type(obj, -2);
 }
-void tcw_cp_cruiser_attack::Timer_Expired(GameObject *obj, int number)
+	else if(type == CUSTOM_EVENT_START_TURRET)
 {
-	if (number == 250)
+		GameObject *Building = Find_Building_By_Type(AttackTeam, param);
+		if(Building)
 	{
-		ActionParamsStruct params;
-		int priority = 100;		float range = 1000.0f;		float deviation = 0.0f;		int primary = 1;
-		params.Set_Basic(this,(float)priority,40016);
-		params.Set_Attack(Commands->Find_Object(Get_Int_Parameter("Attack_ID")),range,deviation,primary);
-		params.AttackCheckBlocked = false;
-		Commands->Action_Attack(obj,params);
-		Commands->Start_Timer(obj,this,1.0f,250);
+			ActionParamsStruct Params;
+			Params.Set_Basic(this, 100, 1);
+			Params.Set_Attack(Commands->Get_Position(Building), 9999, 0, true);
+			Params.AttackCheckBlocked = false;
+			Params.AttackForceFire = true;
+			Commands->Action_Attack(obj, Params);
 	}
 }
-void tcw_cp_cruiser_attack::Action_Complete(GameObject *obj,int action,ActionCompleteReason reason)
+	else if(type == CUSTOM_EVENT_STOP_TURRET)
 {
-	Commands->Action_Reset(obj,100);
+		ActionParamsStruct Params;
+		Params.Set_Basic(this, 100, 1);
+		Params.Set_Attack(0, 9999, 0, true);
+		Commands->Action_Attack(obj, Params);
+	}
 }
 
-ScriptRegistrant<tcw_cp_cruiser_attack> tcw_cp_cruiser_attack_Registrant("tcw_cp_cruiser_attack","Attack_ID=1111:int,TurretID=0:int");
-ScriptRegistrant<tcw_cp_cruiser_countdown> tcw_cp_cruiser_countdown_Registrant("tcw_cp_cruiser_countdown","Team=0:int,NodTurretBar_ID=1:int,NodTurretRef_ID=1:int,GDITurretHon_ID=1:int,GDITurretRef_ID=1:int");
-ScriptRegistrant<tcw_cp_cruiser_countdown_point> tcw_cp_cruiser_countdown_point_Registrant("tcw_cp_cruiser_countdown_point","NodVeh1=asdf:string,NodVeh1Pos=0:vector3,NodVeh1Facing=0:float,NodVeh2=asdf:string,NodVeh2Pos=0:vector3,NodVeh2Facing=0:float,GDIVeh1=asdf:string,GDIVeh1Pos=0:vector3,GDIVeh1Facing=0:float,GDIVeh2=asdf:string,GDIVeh2Pos=0:vector3,GDIVeh2Facing=0:float,SpawnPad1ID=0:int,SpawnPad2ID=0:int,SpawnPad3ID=0:int,SpawnPad4ID=0:int");
\ No newline at end of file
+ScriptRegistrant<TCW_CP_Cruiser_Attack> tcw_cp_cruiser_attack_Registrant("tcw_cp_cruiser_attack","");
+ScriptRegistrant<TCW_CP_Cruiser_Countdown_Point> tcw_cp_cruiser_countdown_point_Registrant("tcw_cp_cruiser_countdown_point","VehSpawnPadID1=0:int,VehSpawnPadID2=0:int,VehSpawnPadID3=0:int,VehSpawnPadID4=0:int,NodTurretID1=0:int,NodTurretID2=0:int,GDITurretID1=0:int,GDITurretID2=0:int,GDIVehicle1:string,GDIVehicle1Pos:vector3,GDIVehicle1Facing=0:float,GDIVehicle2:string,GDIVehicle2Pos:vector3,GDIVehicle2Facing=0:float,NodVehicle1:string,NodVehicle1Pos:vector3,NodVehicle1Facing=0:float,NodVehicle2:string,NodVehicle2Pos:vector3,NodVehicle2Facing=0:float");
\ No newline at end of file
diff -uwrN sourceold/scripts/tcw_center_point.h source/scripts/tcw_center_point.h
--- sourceold/scripts/tcw_center_point.h	2012-06-09 08:11:12.314453100 +0800
+++ source/scripts/tcw_center_point.h	2012-08-04 10:17:08.606445300 +0800
@@ -13,31 +13,80 @@
 */
 #pragma once
 
-class tcw_cp_cruiser_countdown_point : public ScriptImpClass {
-	void Created(GameObject *obj);
-	void Damaged(GameObject *obj, GameObject *damager, float damage);
-	public: void Register_Auto_Save_Variables();
-	bool create_cruiser_countdown_object;
-	bool trigger_neutral_damage;
-	int gdiveh1id; int gdiveh2id; int nodveh1id; int nodveh2id;
-	int nod_bar_turret_id; 	int nod_ref_turret_id; 	int gdi_hand_turret_id; int gdi_ref_turret_id;
-	int spawnpad1;	int spawnpad2;	int spawnpad3;	int spawnpad4;
-}; 
+#pragma warning(disable: 4239 4706)
 
-class tcw_cp_cruiser_countdown : public ScriptImpClass {
+class TCW_CP_Cruiser_Countdown_Point : public ScriptImpClass
+{
+	class VehicleReinforcements
+	{
+		public:
+			VehicleReinforcements()
+			{
+				CreatePreset = "";
+				CreatePos = Vector3(0,0,0);
+				CreateFacing = 0;
+				CreateTeam = -2;
+				PresetID = 0;
+			}
+			VehicleReinforcements(const char *Preset, Vector3 &Pos, float Facing, int Team)
+			{
+				CreatePreset = Preset;
+				CreatePos = Pos;
+				CreateFacing = Facing;
+				CreateTeam = Team;
+				PresetID = 0;
+			}
+			GameObject *Is_Alive_And_Kicking()
+			{
+				GameObject *Preset = Commands->Find_Object(PresetID);
+				if(!Preset || Commands->Get_Health(Preset) < 0)
+					return 0;
+				return Preset;
+			}
+			void Create()
+			{
+				GameObject *Preset = 0;
+				if(Preset = Is_Alive_And_Kicking())
+					Commands->Apply_Damage(Preset, 99999, "BlamoKiller", 0);
+				Preset = Commands->Create_Object(CreatePreset.Peek_Buffer(), CreatePos);
+				Commands->Set_Facing(Preset, CreateFacing);
+				Commands->Set_Player_Type(Preset, CreateTeam);
+				StringClass Str;
+				Str.Format("%d", CreateTeam);
+				Commands->Attach_Script(Preset, "tcw_domination_vehicle", Str.Peek_Buffer());
+				PresetID = Commands->Get_ID(Preset);
+			}
+		protected:
+			StringClass CreatePreset;
+			Vector3 CreatePos;
+			float CreateFacing;
+			int CreateTeam;
+			int PresetID;
+	};
+	VehicleReinforcements *Vehs[4];
+	~TCW_CP_Cruiser_Countdown_Point()
+	{
+		for(int Index = 0; Index < 4; Index++)
+		{
+			delete Vehs[Index];
+			Vehs[Index] = 0;
+		}
+	}
 	void Created(GameObject *obj);
+	void Damaged(GameObject *obj, GameObject *damager, float damage);
 	void Timer_Expired(GameObject *obj, int number);
-	public: void Register_Auto_Save_Variables();
-	int team;
-	int turretbarnod;
-	int turretrefnod;
-	int turrethongdi;
-	int turretrefgdi;
+	int SpawnPadIDs[4];
+	int NodTurretIDs[2];
+	int GDITurretIDs[2];
+	bool Captured;
+	int CaptureType;
+	float Health;
 }; 
 
-class tcw_cp_cruiser_attack : public ScriptImpClass {
+class TCW_CP_Cruiser_Attack : public ScriptImpClass
+{
 	void Created(GameObject *obj);
 	void Action_Complete(GameObject *obj,int action,ActionCompleteReason reason);
-	void Timer_Expired(GameObject *obj, int number);
+	void Custom(GameObject *obj,int type,int param,GameObject *sender);
+	int AttackTeam;
 };
-
